"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.captureForgingStatusAtSnapshotHeight = void 0;
const path_1 = require("path");
const constants_1 = require("./constants");
const fs_1 = require("./utils/fs");
const captureForgingStatusAtSnapshotHeight = (_this, client, snapshotHeight, outputDir) => {
    client.subscribe(constants_1.EVENT_NEW_BLOCK, async (data) => {
        const { block: encodedBlock } = data;
        const newBlock = client.block.decode(Buffer.from(encodedBlock, 'hex'));
        if (newBlock.header.height === snapshotHeight) {
            const forgingStatus = await client.invoke('app:getForgingStatus');
            if (forgingStatus.length) {
                const forgingStatusJsonFilepath = (0, path_1.resolve)(outputDir, 'forgingStatus.json');
                try {
                    await (0, fs_1.write)(forgingStatusJsonFilepath, JSON.stringify(forgingStatus, null, 2));
                    _this.log(`\nFinished exporting forging status to ${forgingStatusJsonFilepath}.`);
                }
                catch (error) {
                    _this.log(`\nUnable to save the node Forging Status information to the disk, please find it below instead:\n${JSON.stringify(forgingStatus, null, 2)}`);
                }
            }
        }
    });
};
exports.captureForgingStatusAtSnapshotHeight = captureForgingStatusAtSnapshotHeight;
//# sourceMappingURL=events.js.map